%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define section free

%define reltag .Final
%define namedversion %{version}%{reltag}
%global _mavenpomdir %{_datadir}/maven2/poms
%bcond_without repolib
%bcond_with mead

Name:           jboss-common-beans
Version:        1.0.1
Release:        2.1%{?reltag}%{?dist}
Epoch:          0
Summary:        JBoss Common core utility classes
License:        LGPLv2+
URL:            http://www.jboss.org/
Group:          Development/Libraries/Java
# git clone git://git.app.eng.bos.redhat.com/jboss/jboss-common-beans.git
# cd jboss-common-beans && git checkout 1.0.1.Final && cd ..
# HEAD is now at 0f1833b... [maven-release-plugin] prepare release 1.0.1.Final
# tar czf jboss-common-beans-1.0.1.Final.tar.gz jboss-common-beans
Source0:        %{name}-%{namedversion}.tar.gz
Patch0:         %{name}-pom.patch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils

BuildRequires:  jpackage-utils
BuildRequires:  unzip
BuildRequires:  maven2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  jboss-parent
BuildRequires:  junit4

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Common Beans utility classes.

%if 0
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{name}
%patch0 -p1

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mvn-jpp \
        -e \
        -Djboss.repository=file://%{_javadir}/repository.jboss.com \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.skip=true \
        -DaltDeploymentRepository=jboss-releases::default::file:`pwd`/maven2-brew \
        deploy

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -p -m 644 target/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -sf ${jar} ${jar/-%{namedversion}/}; done)

# pom
install -d -m 755 %{buildroot}%{_mavenpomdir}
install -p -m 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom

# depmap
%add_to_maven_depmap org.jboss.common %{name} %{namedversion} JPP %{name}

%if 0
# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
unzip -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar \
      -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
rm -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
pushd %{buildroot}%{_javadocdir} 
ln -s %{name}-%{namedversion} %{name}
popd
%endif

%if %{with} repolib
    %{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
    %{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
    install -d -m 755 $RPM_BUILD_ROOT%{repodir}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
    install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if 0
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Jul 26 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.0.1-2.1
- Merge with jb-eap-5-rhel-6 1.0.1-2

* Thu Jul 26 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.0.1-2
- Fix groupId in maven fragment

* Mon Jul 09 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-1
- Build 1.0.1
